#!/bin/sh
CF=/dev/ide/host0/bus0/target1/lun0
MD=/lib/modules/$(uname -r)
IM=/sbin/insmod
POP_CONF="/var/tuxbox/config/popup.conf"
SIZE=$(grep ^SIZE=.* $POP_CONF | cut -d '=' -f 2)
TIME_POPUP=30
if [ -e /var/etc/.mmc_on ] ; then

msg=/tmp/inst.txt
msg1=/tmp/inst1.txt

wait_msgbox ()
{
	while [ 1 ]
	do
	if pidof msgbox > /dev/null; then
	xsleep 500000
	killall msgbox
	break
	fi
	xsleep 500000
	done
}

MSGBOX1 ()
{
echo ~cbitte warten ... >> $msg1
msgbox refresh=0 size=$SIZE timeout=90 title="none" popup=$msg1
rm $msg1
}

part_cf ()
{
echo ~cCF-Karte wird partitioniert. > $msg1
echo ~cAlle Daten werden gel~oscht >> $msg1
echo ~s >> $msg1
echo ~c~YDauer des Vorgangs bei einer 2GIG CF-Karte >> $msg1
echo ~c~Yca. ~S1 ~YMinute >> $msg1
echo ~s >> $msg1
wait_msgbox &
MSGBOX1
if mount | grep 'ide/host0/bus0/target1/lun0' > /dev/null; then
	/etc/init.d/unmount_cf
	umount /mmc
	sleep 1
fi
echo "Create the partition label"
CF=/dev/ide/host0/bus0/target1/lun0
fdisk $CF/disc << EOF
o
n
p
1
1

p
w
q
EOF

}

part_cf_swap ()
{
echo ~cCF-Karte wird partitioniert. > $msg1
echo ~cAlle Daten werden gel~oscht. >> $msg1
echo ~cSWAP Partition wird eingerichtet. >> $msg1
echo ~s >> $msg1
echo ~c~YDauer des Vorgangs bei einer 2GIG CF-Karte >> $msg1
echo ~c~Yca. ~S1 ~YMinute >> $msg1
echo ~s >> $msg1
wait_msgbox &
MSGBOX1
if mount | grep 'ide/host0/bus0/target1/lun0' > /dev/null; then
	/etc/init.d/unmount_cf
	umount /mmc
	sleep 1
fi
CF=/dev/ide/host0/bus0/target1/lun0
if [ -e /tmp/.swap -a -e /var/etc/.cf_swap ] ; then
	swapoff $CF/part1
fi
sleep 3
echo "Create the partition label"
fdisk $CF/disc << EOF
o
n
p
1
1
+64M
n
p
2



t
1
82
p
w
q
EOF

}

test_part ()
{
CF=/dev/ide/host0/bus0/target1/lun0
fdisk $CF/disc << EOF
p
EOF

}

test_cf ()
{
CF=/dev/ide/host0/bus0/target1/lun0
fdisk $CF/disc << EOF
p
EOF

}

echo ~cBei der ersten Inbetriebnahme muss die CF Karte > $msg
echo ~cformatiert werden. Sollten sich bereits Daten auf >> $msg
echo ~cder Karte befinden werden diese gel~oscht. >> $msg
echo ~s  >> $msg
echo ~c~YEine bereits formatierte CF Karte kann nachtr~aglich >> $msg
echo ~c~Yauf ~SEXT2 ~Ybzw. ~SEXT3 ~Yumformatiert werden. >> $msg
echo ~s>> $msg

MSGBOX ()
{
if [ -e /var/tuxbox/config/glj_conf/speicher.conf ] ; then
	/bin/msgbox title="CF Utilitys" refresh=1 order=2 absolute=1 size=$SIZE msg="$msg" select="MOUNT-Test,CF/RAM Speicherauslastung,CF mit EXT2 formatieren,CF mit EXT3 formatieren,CF ohne SWAP partitionieren,CF mit SWAP partitionieren" timeout=300
else
	/bin/msgbox title="CF Utilitys" refresh=1 order=2 absolute=1 size=$SIZE msg="$msg" select="MOUNT-Test,,CF mit EXT2 formatieren,CF mit EXT3 formatieren,CF ohne SWAP partitionieren,CF mit SWAP partitionieren" timeout=300
fi
case "$?" in
	1)
		if mount | grep 'ide/host0/bus0/target1/lun0' > /dev/null; then
			echo ~cCF-Karte ist gemountet. > $msg
		else
			if [ -e /var/etc/.mmc_ext2 ] ; then
				if test_cf | grep '82  Linux swap' > /dev/null; then
					/bin/mount -t ext2 $CF/part2 /mmc
				else
					/bin/mount -t ext2 $CF/part1 /mmc
				fi
			fi
			if [ -e /var/etc/.mmc_ext3 ] ; then
				if test_cf | grep '82  Linux swap' > /dev/null; then
					/bin/mount -t ext3 $CF/part2 /mmc
				else
					/bin/mount -t ext3 $CF/part1 /mmc
				fi
			fi
			sleep 1
			if mount | grep 'ide/host0/bus0/target1/lun0' > /dev/null; then
				echo ~cCF-Karte ist gemountet. > $msg
			else
				echo ~cCF-Karte kann nicht gemountet werden. > $msg
				echo ~s~c >> $msg
				echo ~cCF-Karte Karte richtig eingebaut und formatiert ? >> $msg
				echo ~cCF-Kartentreiber richtig geladen ? >> $msg
			fi
		fi
		MSGBOX
		;;
	2)
		Flexmenu="/var/plugins/shellexec"
		menu=/tmp/.speicher
		param () {
		echo FONT=/share/fonts/micron_bold.ttf > $menu
		echo KILLEPG=2 >> $menu
		echo TIMESERVICE=NONE >> $menu
		echo HIGHT=420 >> $menu
		echo WIDTH=520 >> $menu
		echo FONTSIZE=20 >> $menu
		echo PAGING=1 >> $menu
		echo LINESPP=12 >> $menu
		echo MENU=HDD-CF-RAM Speicherauslastung >> $menu
		cat /var/tuxbox/config/glj_conf/speicher.conf >> $menu
		echo ENDMENU >> $menu
	       }
	       param
	       $Flexmenu "$menu"
	       rm $menu
	       MSGBOX
	;;
	3)
		echo ~cCF-Karte wird mit EXT2 formatiert > $msg1
		echo ~cAlle Daten werden gel~oscht >> $msg1
		echo ~s >> $msg1
		echo ~c~YDauer des Vorgangs bei einer 2GIG CF-Karte >> $msg1
		echo ~c~Yca. ~S1 ~YMinute >> $msg1
		echo ~s >> $msg1
		wait_msgbox &
		MSGBOX1
		if mount | grep 'ide/host0/bus0/target1/lun0' > /dev/null; then
			/etc/init.d/unmount_cf
			umount /mmc
			xsleep 500000
		fi
		if (lsmod | grep ext3 > /dev/null || [ -e /var/etc/.mmc_ext3 ]) && [ ! -e /var/etc/.ide_ext3 -o ! -e /var/etc/.start_ide ] ; then rmmod ext3; rmmod jbd; fi
		[ ! -e /var/etc/.mmc_ext2 ] && touch /var/etc/.mmc_ext2
		[ -e /var/etc/.mmc_ext3 ] && rm /var/etc/.mmc_ext3
		if ! lsmod | grep ext2 > /dev/null ; then $IM ext2; fi
		xsleep 500000
		if test_cf | grep '82  Linux swap' > /dev/null; then
			mkfs.ext2 $CF/part2
			sleep 2
			/bin/mount -t ext2 $CF/part2 /mmc
		else
			mkfs.ext2 $CF/part1
			sleep 2
			/bin/mount -t ext2 $CF/part1 /mmc
		fi
		sleep 1
		if mount | grep 'ide/host0/bus0/target1/lun0' > /dev/null; then
			mkdir -p /mmc/.backup
			mkdir -p /mmc/image
			echo ~cCF-Karte wurde mit EXT2 formatiert. > $msg
			echo ~c~s >> $msg
			echo ~c~YCF-Karte ist nach /mmc gemountet. >> $msg
		else
			echo ~c~FFEHLER !! > $msg
			echo ~cCF-Karte ~Ywurde nicht richtig formatiert. >> $msg
			if ! lsmod | grep ext2 > /dev/null ; then
				echo ~cTreiber ~YEXT2 ~Sist nicht geladen. >> $msg
			fi
			echo ~c~s >> $msg
			echo ~cVorgang wiederholen oder abbrechen ? >> $msg
		fi
		killall msgbox
		MSGBOX
		;;
	4)
		echo ~cCF-Karte wird mit EXT3 formatiert > $msg1
		echo ~cAlle Daten werden gel~oscht >> $msg1
		echo ~s >> $msg1
		echo ~c~YDauer des Vorgangs bei einer 2GIG CF-Karte >> $msg1
		echo ~c~Yca. ~S1 ~YMinute >> $msg1
		echo ~s >> $msg1
		wait_msgbox &
		MSGBOX1
		if mount | grep 'ide/host0/bus0/target1/lun0' > /dev/null; then
			/etc/init.d/unmount_cf
			umount /mmc
			xsleep 500000
		fi
		if (lsmod | grep ext2 > /dev/null || [ -e /var/etc/.mmc_ext2 ]) && [ -e /var/etc/.noide_ext2 -o ! -e /var/etc/.start_ide ] ; then rmmod ext2; fi
		[ -e /var/etc/.mmc_ext2 ] && rm /var/etc/.mmc_ext2
		[ ! -e /var/etc/.mmc_ext3 ] && touch /var/etc/.mmc_ext3
		if ! lsmod | grep jbd > /dev/null ; then $IM jbd; fi
		if ! lsmod | grep ext3 > /dev/null ; then $IM ext3; fi
		xsleep 500000
		if test_cf | grep '82  Linux swap' > /dev/null; then
			mkfs.ext3 $CF/part2
			sleep 2
			/bin/mount -t ext3 $CF/part2 /mmc
		else
			mkfs.ext3 $CF/part1
			sleep 2
			/bin/mount -t ext3 $CF/part1 /mmc
		fi
		sleep 1
		if mount | grep 'ide/host0/bus0/target1/lun0' > /dev/null; then
			mkdir -p /mmc/.backup
			mkdir -p /mmc/image
			echo ~cCF-Karte wurde mit EXT3 formatiert. > $msg
			echo ~c~s >> $msg
			echo ~c~YCF-Karte ist nach /mmc gemountet. >> $msg
		else
			echo ~c~FFEHLER !! > $msg
			echo ~cCF-Karte ~Ywurde nicht richtig formatiert. >> $msg
			if ! lsmod | grep ext3 > /dev/null ; then
				echo ~cTreiber ~YEXT3 ~Sist nicht geladen. >> $msg
			fi
			echo ~c~s >> $msg
			echo ~cVorgang wiederholen oder abbrechen ? >> $msg
		fi
		killall msgbox
		MSGBOX
		;;
	5)
		part_cf
		sleep 1
		if test_part | grep '83  Linux' > /dev/null; then
			mkdir -p /mmc/.backup
			mkdir -p /mmc/image
			echo ~c~YCF-Karte ~Swurde erfolgreich partitioniert und > $msg
			echo ~ckann jetzt mit dem gew~unschten Filesystem >> $msg
			echo ~cformatiert werden. >> $msg
		else
			echo ~c~FFEHLER !! > $msg
			echo ~cCF-Karte ~Ywurde nicht richtig partitioniert. >> $msg
			echo ~c~s >> $msg
			echo ~cVorgang wiederholen oder abbrechen ? >> $msg
		fi
		rm /tmp/partition
		killall msgbox
		MSGBOX
		;;
	6)
		part_cf_swap
		sleep 1
		mkswap $CF/part1
		if test_part | grep '83  Linux' > /dev/null; then
			mkdir -p /mmc/.backup
			mkdir -p /mmc/image
			echo ~c~YCF-Karte ~Swurde erfolgreich partitioniert und > $msg
			echo ~ckann jetzt mit dem gew~unschten Filesystem >> $msg
			echo ~cformatiert werden. SWAP wurde eingerichtet. >> $msg
			if [ -e /tmp/.swap -a -e /var/etc/.cf_swap ] ; then
				sleep 1
				/sbin/swapon $CF/part1 && /bin/mount -n -t tmpfs tmpfs /tmp -o size=64M,remount
			fi
		else
			echo ~c~FFEHLER !! > $msg
			echo ~cCF-Karte ~Ywurde nicht richtig partitioniert. >> $msg
			echo ~c~s >> $msg
			echo ~cVorgang wiederholen oder abbrechen ? >> $msg
		fi
		rm /tmp/partition
		killall msgbox
		MSGBOX
		;;
	*)
		[ -e $msg ] && rm $msg
		[ -e $msg1 ] && rm $msg1
		exit
		;;
		esac
}
MSGBOX
else
/bin/msgbox msg="Keine ~YCF Treiber ~Saktiviert und geladen!~n~cBitte CF Treiber im Men~u aktivieren~n~cund ~YMen~u CF ~SUtilitys neu aufrufen !" timeout=$TIME_POPUP size=$SIZE
killall msgbox
fi